// Here we avoid loading the header multiple times
#ifndef KPERSO_HEADER
#define KPERSO_HEADER
// We need the Plasma Applet headers
#include <KIcon>

#include <Plasma/Applet>

namespace Plasma {
    class Label;    
    class PushButton;
}

class KConfigDialog;

class QAction;
class QSizeF;
class QTextDocument;
class Query;

// Define our plasma Applet
class PersonalKwery : public Plasma::Applet
{
    Q_OBJECT
    public:
        // Basic Create/Destroy
        PersonalKwery(QObject *parent, const QVariantList &args);
        ~PersonalKwery();

        // The paintInterface procedure paints the applet to screen
        void paintInterface(QPainter *painter,
                const QStyleOptionGraphicsItem *option,
                const QRect& contentsRect);
        void init();

        virtual void configChanged();

    private:
        void enableControls();
        void loadConfig();
        void saveConfig();
    
    protected:
        virtual void createConfigurationInterface(KConfigDialog* parent);

    private slots:
        void slotUpdateError(int errorCode, QString msg);
        void slotUpdateText(const QString & text);
        void slotRefresh();

    private:
        Query* m_query;
        QTextDocument* m_document;
        QString m_text;

        QAction* m_refresh;
        Plasma::PushButton* m_btnRefresh;
        Plasma::Label* m_lblError;

        bool m_bIsError;

};
 
// This is the command that links your applet to the .desktop file
K_EXPORT_PLASMA_APPLET(personalkwery, PersonalKwery)
#endif
