
#ifndef QUERY_CONFIGURATION_H
#define QUERY_CONFIGURATION_H

#include <QMap>
#include <QString>

class QueryConfiguration {
public:
    QueryConfiguration();
    QueryConfiguration(const QueryConfiguration & rhs);

    const QueryConfiguration & operator=(const QueryConfiguration & rhs );

    inline void setQueryInterval(int interval) { m_queryInterval = interval; }
    inline int queryInterval() const { return m_queryInterval; }

    inline void setName( const QString & name ) { m_name = name; }
    inline const QString & name() const { return m_name; }

    inline void setBaseUrl( const QString & baseUrl ) { m_baseUrl = baseUrl; }
    inline const QString & baseUrl() const { return m_baseUrl; }

    inline void setAttributes( const QMap<QString,QString> & map ) { m_attributes = map; }
    inline const QMap<QString,QString> attributes() const { return m_attributes; }

    inline void setXslt( const QString & xslt ) { m_xslt = xslt; }
    inline const QString & xslt() const { return m_xslt; }

    inline void setReturnedDataIsHtml(bool html) { m_returnedDataIsHtml = html; }
    inline bool returnedDataIsHtml() const { return m_returnedDataIsHtml; }

    bool readFromFile(const QString & filename);
    bool saveToFile(const QString & filename) const;

private:
    int m_queryInterval;
    QString m_name;
    QString m_baseUrl;
    QMap<QString,QString> m_attributes;

    QString m_xslt;

    bool m_returnedDataIsHtml;
};


#endif 
