
#ifndef QUERY_WIDGET_H
#define QUERY_WIDGET_H

#include "ui_querywidget.h"

class QueryConfiguration;
class Query;

class QueryWidget : public QWidget {
    Q_OBJECT
public:
    QueryWidget(const QueryConfiguration & configuration, QPushButton* buttonOk, QWidget* parent = NULL);
    ~QueryWidget();

    QueryConfiguration configuration() const;

private slots:
    void slotAddAttribute();
    void slotRemoveAttribute();
    void slotEnableControls();
    void slotTest();
    void slotTestQueryDone();
    void slotTestQueryFailed(int error, QString msg);

private:
    Ui::QueryWidget m_widget;
    QPushButton* m_buttonOk;

    Query* m_query;
};

#endif // QUERY_WIDGET_H

